#include <xc.inc>
    
GLOBAL _Random
GLOBAL _match
GLOBAL _button4
GLOBAL _delay
GLOBAL _delay1
GLOBAL _delay0
    
PSECT text0,class=CODE,reloc=2

// variable delays
Delay:
 movlw 0XFF
 movwf _delay1,0
repeat:
 movf _delay,0,0
 movwf _delay0,0
dloop:
 nop
 nop
 nop
 nop
 decfsz _delay0,1,0 // decrement delay0 and skip when zero
 goto dloop

 decfsz _delay1,1,0 // decrement delay1 and skip when zero
 goto repeat
return // end Delay:    
    
    
// match function  
_match:
    
 call _HWsetup // setup the hardware
 call _Random  // empty function call
 
 movlw 100
 movwf _delay,0 // set the Delay length
    
 movlw 0x00
 movwf _button4,0 // clear button4
 
 movlw 0b11011000
 movwf INTCON,0  // enable GIE, PIE, INT0IE and RBIE

 // loop until button4 has been pressed
 movlw 1
wait4:
 CPFSEQ _button4, 0
 goto wait4
 
 // button4 has been pressed
 movlw 0X00
 movwf INTCON,0 // turn off all interrupts
 movf PORTB,0,0 // read PORTB
 
 movlw 0
 movwf _button4, 0    // clear button4

 movlw 0b00000110
 movwf PORTC,0 // turn on some leds
 call Delay
 
 movlw 0X00
 movwf PORTC,0 // turn off all leds

 movlw 0b11011000
 movwf INTCON,0 // enable GIE, PIE, INT0IE and RBIE 
 movf PORTB,0,0 // read PORTB
 
 // loop until button4 has been pressed
 movlw 1
wait5:
 CPFSEQ _button4, 0
 goto wait5

 // button4 has been pressed
 movlw 0X00
 movwf INTCON,0 // turn off all interrupts
 movf PORTB,0,0 // read PORTB

 movlw 0
 movwf _button4, 0    // clear button4
 
 movlw 0b01000001
 movwf PORTC,0 // turn on some leds
 call Delay
    
 movlw 0X00
 movwf PORTC,0 // turn off all leds
 
return // end of _match

    
    
 PSECT text0,class=CODE,reloc=2
 // hardware setup function
_HWsetup:
 movlw 0b01000010 // oscillator frequency 1 mhz
 movwf OSCCON,0

 movwf ADCON0,0   // Turn off  all ADC

 movlw 0x0F
 movwf ADCON1,0   // Disable all analog functions

 movlw 0x00
 movwf TRISA,0    // All PORTA as outputs
 movlw 0b11111111
 movwf PORTA,0    // All PORTA high

 movlw 0b11110001
 movwf TRISB,0    // PORTB 1,2,3 as output and 0,4,5,6,7 as interrupts

 movlw 0x00
 movwf TRISC,0    // All PORTC as output
 movwf PORTC,0    // All PORTC low
 
 BCF RBPU      // Enable pull-up on PORTB
 BCF INTEDG0   // Falling edge asserts external interrupt
 
 movlw 0X00
 movwf INTCON,0 // clear all interrupts
 movf PORTB,0,0 // read PORTB

return // end of _HWsetup:
 
 
 
PSECT textISR,class=CODE,reloc=4
;interrupt function
isr:
    ;check for external interrupt on PORTB 0
    btfsc       INT0IE   ;is INTO enabled?
    btfss       INT0IF   ;it is, so check the flag
    goto        notINT0F ;not an external interrupt
    bcf         INT0IF   ;it is, so clear the INT0IF flag
    movf PORTB,0,0       ;read PORTB
    movlw 1
    movwf _button4, 0    ;set the button4 variable
    goto exitISR         ;now get out
notINT0F:
    ;check for IOC on PORTB 4,5,6,7
    btfsc     RBIE       ;is RBIE enabled?
    btfss     RBIF       ;it is, so check the flag
    goto exitISR         ;not an IOC interrupt
    bcf        RBIF      ;clear the RBIF flag
    movf PORTB,0,0       ;read PORTB
    movlw 1
    movwf _button4, 0    ;set the button4 variable 
exitISR:
retfie  ;return from interrupt

END

